Option Explicit
Public WshShell, WshNetwork, objXmlDoc, objFSO, objFSO2, objWMIService, DocumentsString, AppFolder, AppFolderString, AppINIPathString, AppINIFileString, AppINIFile, CubaseVersion, oss, os, strComputer, strErrText
Public categTable, keyTable, combTable, commandTable(), objRoot, objAttrChild0Value, collNodes, collNodes2, collNodes3, collNodes4, objNode, objNode2, objNode3, objNode4
Public ub_keyTable, ub_combTable, ub_categTable, ct_Key, ct_Comb, ct_Categ
keyTable = Array( _
  "F1","F2","F3","F4","F5","F6","F7","F8","F9","F10","F11","F12", _
  "`","²","1","2","3","4","5","6","7","8","9","0", _
  "'","`","<",">","[","]","{","}","(",")","/","\","?","","!","", _
  "-","=","_","+","|",",",".",";","'","#","","^","", _
  "","%","","","","@","&","","$","","*", _
  "A","B","C","D","E","F","G","H","I","J","K","L","M", _
  "N","O","P","Q","R","S","T","U","V","W","X","Y","Z", _
  "Esc","Pause","Scroll","Backspace","Return","Space","Insert","Del","Home","End","PgUp","PgDown","Left Arrow","Up Arrow","Right Arrow","Down Arrow", _
  "Pad0","Pad1","Pad2","Pad3","Pad4","Pad5","Pad6","Pad7","Pad8","Pad9","Pad .","Pad /","Pad *","Pad -","Pad +","Enter" _
  )
ub_keyTable = UBound(keyTable)
categTable = Array("AddTrack","ADDT","Analyze","ANLZ","Arranger","ARRG","Audio","AUDI","Audio Export","AUEX","Audio Realtime Processing","AURP","Automation","AUTO","Beat Designer","BEAD", _
  "Chords","CHRD","Control Room","CTRM","Devices","DEVI","Edit","EDIT","Editors","EDTR","Export","EXPR","File","FILE","Focus","FCUS","Hitpoints","HITP","Hub","HUB ","Import","IMPR","Inspector","INSP", _
  "Macro","MACR","Media","MDIA","MIDI","MIDI","MIDI Quantize","MIDQ","Mixer","MIXR","Navigate","NAVG","Note Expression","NEXP","Nudge","NDGE","Preferences","PREF","Preset","PRES", _
  "Process","PRCS","Process Logical Preset","PRLP","Process Plug-in","PRPI","Process Project Logical Editor","PPLE","Project","PROJ","Quantize Category","QCAT","Sample Editor","SMPE", _
  "Scores","SCOR","Score Align Elements","SCAE","Score Functions","SCFN","Score Meter Scale","SCMS","Scores Statusbar","SCSB","Score Symbol Palettes","SCSP","Set Insert Length","SINL", _
  "Transport","TRAN","Tool","TOOL","Windows","WIND","Workspaces","WRKS","Zoom","ZOOM" _
  )
ub_categTable = UBound(categTable)
combTable = Array("", "Ctrl", "Shift", "Alt", "Ctrl+Shift", "Ctrl+Alt", "Alt+Shift", "Ctrl+Alt+Shift")
ub_combTable = UBound(combTable)
Redim commandTable(ub_keyTable,ub_combTable)
for ct_Key = 0 to ub_keyTable
	for ct_Comb = 0 to ub_combTable
		commandTable(ct_Key,ct_Comb) = ""
	next
next

Get_KCSettings
set objXmlDoc = Nothing
set objFSO = Nothing
set objFSO2 = Nothing
Set WshShell = Nothing
err_Check
WScript.Quit

'---------------------------------------
Sub Get_KCSettings
dim CubasePrefsFolder, CubasePrefsFolderString, CubaseKCFile, CubaseKCFileString, KC_File, KCTMP_File
dim CPFString, iniLine, KC_CmdString, KC_StrokeString, NodeAttrib, flag_existCommand, flag_categFound, ct_lines, mod_lines, len_Comb, empty_Comb, mod_Comb, suff_Comb
On error resume next
CubasePrefsFolderString = ""
CubaseVersion = ""
Set WshShell = CreateObject("WScript.Shell")
Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objFSO2 = CreateObject("Scripting.FileSystemObject")
DocumentsString = WshShell.SpecialFolders("MyDocuments")
AppINIPathString = DocumentsString
if not objFSO.FolderExists(AppINIPathString) then
	err_PrefFSO AppINIPathString, 0
end if
AppINIFileString = AppINIPathString & "\CubasePrefsPath.ini"
if objFSO.FileExists(AppINIFileString) then
	Set AppINIFile = objFSO.OpenTextFile(AppINIFileString, 1)
else
	err_PrefFSO AppINIFileString, 1
end if
CPFString = ""
Do While AppINIFile.AtEndOfStream = False
	iniLine = Left(Trim(AppINIFile.ReadLine), 18)
	If LCase(iniLine) = "[preferences path]" Then
		CPFString = AppINIFile.ReadLine
		CPFString = Trim(Mid(CPFString, InStr(CPFString, "=") + 1))
		CubaseVersion = Trim(Mid(CPFString, InStrRev(CPFString, "\")))
		Exit do
	end if
Loop
AppINIFile.close
Set WshNetwork = WScript.CreateObject("WScript.Network")
strComputer = "."
Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
Set oss = objWMIService.ExecQuery ("Select * from Win32_OperatingSystem")
for each os in oss
	select case left(os.Version,1)
	case "5"
		CubasePrefsFolderString = "c:\Documents and Settings\" & WshNetwork.UserName & CPFString
	case "6"
		CubasePrefsFolderString = "c:\users\" & WshNetwork.UserName & CPFString
	case else
		err_WinVersion os.Version
	end select
next
Set oss = Nothing
Set objWMIService = Nothing
Set WshNetwork = Nothing
set objFSO = Nothing
Set objFSO = CreateObject("Scripting.FileSystemObject")
if objFSO.FolderExists(CubasePrefsFolderString) then
	CubasePrefsFolder = objFSO.GetFolder(CubasePrefsFolderString)
else
	err_PrefFSO CubasePrefsFolderString, 2
end if
AppFolderString = DocumentsString
if not objFSO.FolderExists(AppFolderString) then
	err_PrefFSO AppFolderString, 0
end if
If objFSO2.FolderExists(AppFolderString & "\CubaseKCSettings") then
	AppFolder = objFSO2.GetFolder(AppFolderString & "\CubaseKCSettings")
else
	AppFolder = objFSO2.CreateFolder(AppFolderString & "\CubaseKCSettings")
end if
Set KC_File = objFSO2.CreateTextFile(AppFolder & CubaseVersion & "_KCSettings.txt", True)
CubaseKCFileString = CubasePrefsFolder & "\Key Commands.xml"
if objFSO.FileExists(CubaseKCFileString) then
	Set CubaseKCFile = objFSO.OpenTextFile(CubaseKCFileString, 1)
else
	KC_File.close
	err_PrefFSO CubaseKCFileString, 3
end if
Set KCTMP_File = objFSO.CreateTextFile(AppFolder & CubaseVersion & "_KeyCommandsTMP.xml", true)
KCTMP_File.write(CubaseKCFile.ReadAll())
CubaseKCFile.close
KCTMP_File.close
KC_File.write(string(33,"/") & vbCrLf)
KC_File.write("/// KEYBOARD COMMANDS SETUP FOR : " & CubasePrefsFolderString & vbCrLf)
KC_File.write(string(33,"/") & vbCrLf & vbCrLf)
On error goto 0
Set objXmlDoc = CreateObject("Microsoft.XMLDOM")
objXmlDoc.validateOnParse = False
objXmlDoc.resolveExternals = False
objXmlDoc.async = False
If Not objXmlDoc.load(AppFolder & CubaseVersion & "_KeyCommandsTMP.xml") Then
	KC_File.close
	err_Parse objXmlDoc, KC_File
end if
On error resume next
Set objRoot = objXmlDoc.documentElement
Set collNodes = objRoot.SelectNodes("*")
for each objNode in collNodes
	NodeAttrib = objNode.getattribute("name")
	ct_Categ = 0
	if NodeAttrib <> "Macros" then
		set collNodes2 = objNode.childnodes
		for each objNode2 in collNodes2
			objAttrChild0Value = objNode2.childnodes(0).getattribute("value")
			ct_Categ = 0
			flag_categFound = false
			do
				if objAttrChild0Value = categTable(ct_Categ) then
					objAttrChild0Value = categTable(ct_Categ+1)
					flag_categFound = true
				end if
				ct_Categ = ct_Categ + 2
			loop while (ct_Categ < ub_categTable) and (not flag_categFound)
			if not flag_categFound then objAttrChild0Value = space(4)
			set CollNodes3 = objNode2.childnodes(1).childnodes
			for each objNode3 in CollNodes3
				if objNode3.childnodes.length > 1 then
					KC_CmdString = objNode3.childnodes(0).getattribute("value")
					KC_StrokeString = ""
					set CollNodes4 = objNode3.childnodes(1).childnodes
					if CollNodes4.length > 0 then
						for each objNode4 in CollNodes4
							KC_StrokeString = objNode4.getattribute("value")
							set_commandTable KC_CmdString, KC_StrokeString, objAttrChild0Value
						next
					else
						KC_StrokeString = objNode3.childnodes(1).getattribute("value")
						set_commandTable KC_CmdString, KC_StrokeString, objAttrChild0Value
					end if
				end if
			next
		next
	end if
next
KC_File.write(space(11) & "|")
for ct_Comb = 0 to 7
	combTable(ct_Comb) = Replace(combTable(ct_Comb), "Alt+Shift", "Shift+Alt")
	if len(combTable(ct_Comb)) > 0 then combTable(ct_Comb) = "[" & UCase(combTable(ct_Comb)) & "]" else combTable(ct_Comb) = ""
	len_Comb = len(combTable(ct_Comb))
	empty_Comb = 31 - len_Comb
	mod_Comb = empty_Comb mod 2
	if mod_Comb	= 1 then suff_Comb = "_" else suff_Comb = ""
	KC_File.write(string((empty_Comb\2),"_") & combTable(ct_Comb) & string((empty_Comb\2),"_") & suff_Comb & "|")
next
KC_File.write(vbCrLf)
ct_lines = 1
for ct_Key = 0 to ub_keyTable
	flag_existCommand = false
	ct_comb = 0
	do
		if commandTable(ct_Key,ct_Comb) <> "" then flag_existCommand = true
		ct_comb = ct_comb + 1
	loop while (not flag_existCommand) and (ct_comb < 8)
	if flag_existCommand then
		mod_lines = ct_lines mod 4
		if mod_lines = 0 then KC_File.write(keyTable(ct_Key) & string(11-len(keyTable(ct_Key)),"_") & "|") else KC_File.write(keyTable(ct_Key) & space(11-len(keyTable(ct_Key))) & "|")
		for ct_Comb = 0 to ub_combTable
			if mod_lines = 0 then KC_File.write(commandTable(ct_Key,ct_Comb) & string(31-len(commandTable(ct_Key,ct_Comb)),"_") & "|") else KC_File.write(commandTable(ct_Key,ct_Comb) & space(31-len(commandTable(ct_Key,ct_Comb))) & "|")
		next
		KC_File.write(vbCrLf)
		ct_lines = ct_lines + 1
	end if
next
set objXmlDoc = Nothing
KC_File.close
WshShell.Run "notepad.exe " & AppFolder & CubaseVersion & "_KCSettings.txt"
end sub

'--------------------------------------
sub set_commandTable (byval KC_CmdString, byval KC_StrokeString, byval objAttrChild0Value)
dim KC_StrokeString2, KC_CombString, KC_KeyString, pos_Separator, pos_Separator2, flag_CombFound, flag_KeyFound, ct_frm
On error resume next
pos_Separator = inStrRev(KC_StrokeString,"+")
if pos_Separator > 0 then
	if pos_Separator = len(KC_StrokeString) then
		KC_StrokeString2 = left(KC_StrokeString, pos_Separator-1) 
		pos_Separator2 = inStrRev(KC_StrokeString2,"+")
		if pos_Separator2 > 0 then 
			KC_CombString = left(KC_StrokeString2, pos_Separator2-1)
			KC_KeyString = right(KC_StrokeString, len(KC_StrokeString)-pos_Separator2)
		else
			KC_CombString = ""
			KC_KeyString = KC_StrokeString
		end if
	else
		KC_CombString = left(KC_StrokeString, pos_Separator-1)
		KC_KeyString = right(KC_StrokeString, len(KC_StrokeString)-pos_Separator)
	end if
else
	KC_CombString = ""
	KC_KeyString = KC_StrokeString
end if
ct_Comb = 0
flag_CombFound = false
do while (not flag_CombFound and ct_Comb <= ub_combTable)
	if KC_CombString = combTable(ct_Comb) then flag_CombFound = true
	ct_Comb = ct_Comb + 1
loop
ct_Key = 0
flag_keyFound = false
do while (not flag_keyFound and ct_Key <= ub_keyTable)
	if KC_KeyString = keyTable(ct_Key) then flag_keyFound = true
	ct_Key = ct_Key + 1
loop
if (flag_keyFound and flag_CombFound) then
	commandTable(ct_Key-1,ct_Comb-1) = objAttrChild0Value & ":" & KC_CmdString
	ct_frm = 1
	do while (len(commandTable(ct_Key-1,ct_Comb-1)) > 31) and (ct_frm < 16)
		Format_CommandTable commandTable(ct_Key-1,ct_Comb-1), ct_frm
		ct_frm = ct_frm + 1
	loop
	commandTable(ct_Key-1,ct_Comb-1) = left(commandTable(ct_Key-1,ct_Comb-1), 31)
end if
end sub

'-------------------------------------------------------------
Sub Format_CommandTable(byref ch_format, byval ct_frm)
dim pos_sep, len_ch_format
select case ct_frm
case 1
	ch_format = replace(ch_format, "oggle", "ogl")
case 2
	ch_format = replace(ch_format, "arameter", "aram")
case 3
	ch_format = replace(ch_format, "rack", "rk")
case 4
	ch_format = replace(ch_format, "election", "lctn")
case 5
	ch_format = replace(ch_format, "elected", "lctd")
case 6
	ch_format = replace(ch_format, "elect", "el")
case 7
	ch_format = replace(ch_format, "ontroller", "trler")
case 8
	ch_format = replace(ch_format, "orkspace", "orksp")
case 9
	ch_format = replace(ch_format, "ncrease", "ncr")
case 10
	ch_format = replace(ch_format, "ecrease", "ecr")
case 11
	ch_format = replace(ch_format, "odulation", "odult")
case 12
	ch_format = replace(ch_format, "reate", "rea")
case 13
	ch_format = replace(ch_format, "emove", "em")
case 14
	ch_format = replace(ch_format, "ption", "pt")
case 15
	len_ch_format = len(ch_format)
	pos_sep = inStr(ch_format," - ")
	if pos_sep > 0 then ch_format = left(ch_format,5) & right(ch_format, len_ch_format - (pos_sep+2))
end select
end Sub

'-------------------------------------------------------------
Sub err_PrefFSO(byVal errFSOString, byVal errFSOObjectType)
select case errFSOObjectType
case 0
	Msgbox "The " & errFSOString & " folder could not be located. Please be sure that the path is a valid one." & vbCrLf & "Application cancelled...", vbCritical, "Folder location error..."
case 1
	Msgbox "The " & errFSOString & " file could not be found. Please, check..." & vbCrLf & "Application cancelled...", vbCritical, "INI file location error"
case 2
	Msgbox "The path : " & errFSOString & " is invalid." & vbCrLf & "Application cancelled...", vbCritical, "Cubase preferences path error"
case 3
	Msgbox "The file : " & errFSOString & " is not available." & vbCrLf & "Application cancelled...", vbCritical, "Cubase preferences file error"
end select
if objFSO2.FileExists(AppFolder & CubaseVersion & "_KCSettings.txt") then objFSO2.deleteFile(AppFolder & CubaseVersion & "_KCSettings.txt")
set objXmlDoc = Nothing
set objFSO = Nothing
set objFSO2 = Nothing
Set WshShell = Nothing
WScript.Quit
end sub

'-------------------------------------------------------------
sub err_WinVersion(byVal errOSVersion)
strErrText = "This utility works only under Windows XP or higher (OS version from 5.1 to 6.3). Currently used OS version : " & errOSVersion
MsgBox strErrText, vbExclamation
set err_objXmlDoc = Nothing
set objFSO = Nothing
set objFSO2 = Nothing
Set WshShell = Nothing
Set oss = Nothing
Set objWMIService = Nothing
set WshNetwork = Nothing
WScript.Quit
end sub

'-------------------------------------------------------------
Sub err_Parse(byref err_objXmlDoc, byref txt_File)
dim objParseError
Set objParseError = err_objXmlDoc.parseError
With objParseError
	strErrText = "The XML temporary file failed to load." & vbCrLf & VbCrLf & _
		"Error #" & .errorCode & " : " & .reason & " - Line # : " & .Line & VbCrLf & _
		"Line Position : " & .linepos & vbCrLf & "Position In File : " & .filepos & vbCrLf & _
		"Source Text : " & .srcText & vbCrLf & "Document URL : " & .url
End With
MsgBox strErrText, vbExclamation
txt_File.close
set err_objXmlDoc = Nothing
set objFSO = Nothing
set objFSO2 = Nothing
Set WshShell = Nothing
WScript.Quit
end sub

'-------------------------------------------------------------
Sub err_Check
If err.number <> 0 then
	MsgBox "Error #" & err.Number & vbCrLf & err.Description & vbCrLf & Err.Source, vbCritical, "Runtime error (custom call)..."
	err.Clear
End if
end sub
